% this program is used to split the sequencing data in txt format into separate files,
% of which each file is of ALN format and only contains the sequencing data on one chromosome 
function marker = step3_split_sequencing_data_2chr(rawdatafile, nchr, workdir)

disp('Start to split raw data file"');
disp('The bed file should have exactly six columns "Chromosom    Start    End    Any_Information    Any_Information    Strand"');

outputdir_root = [workdir, 'rawdata_chr\'];
[pathstr, TFname, ext, versn] = fileparts(rawdatafile);

% whether to creat folder to store files
if_mkdir = 1;
filename = dir(workdir);
for i = 1:length(filename);
    if strcmp(filename(i).name, 'rawdata_chr') && filename(i).isdir
        if_mkdir = 0;
        break;
    end
end

if if_mkdir
    mkdir(workdir, 'rawdata_chr');
end

for chr_id = 1:nchr,
    switch chr_id,
        case nchr-1,
            chr_id_str = 'chrX';
            case nchr,
            chr_id_str = 'chrY';
        otherwise,
            chr_id_str = ['chr', int2str(chr_id)];
    end
    
    if_mkchrdir = 1;
    filename = dir(outputdir_root);
    for i = 1:length(filename);
        if strcmp(filename(i).name, chr_id_str) && filename(i).isdir
            if_mkchrdir = 0;
            break;
        end
    end

    if if_mkchrdir
        mkdir(outputdir_root, chr_id_str);
    end
end

% start of reading raw data
linenum = 100000;       % number of line to read at one time

if 1,
    for chr_id = 1:nchr,
        switch chr_id,
            case nchr-1,
                chr_id_str = 'chrX';
            case nchr,
                chr_id_str = 'chrY';
            otherwise,
                chr_id_str = ['chr', int2str(chr_id)];
        end
        
        outputdir = [outputdir_root, chr_id_str, '/'];
        outputfile = [outputdir, TFname, '.', chr_id_str, '.txt'];
        fw(chr_id) = fopen(outputfile, 'w');
    end
    
    if 1
        fs = fopen(rawdatafile, 'r');

        end_of_file = 1;
        cnt = 0;
        while end_of_file
            clear CC;
            CC = textscan(fs, '%s%s%s%s%s%s%*[^\n]', linenum);
            
            nline = length(CC{1});
            cnt = cnt + 1;
            if nline == linenum
                end_of_file = 1;
            else
                end_of_file = 0;
            end
            
            for chr_id = 1:nchr,
                switch chr_id,
                    case nchr-1,
                        chr_id_str = 'chrX';
                    case nchr,
                        chr_id_str = 'chrY';
                    otherwise,
                        chr_id_str = ['chr', int2str(chr_id), ''];
                end
                
                I = find(strcmp(CC{1}, chr_id_str));
                for tt = 1:length(I)
                    fprintf(fw(chr_id), '%s\t%s\t%s\n', CC{1}{I(tt)}, CC{2}{I(tt)},  CC{6}{I(tt)});
                end
            end
            
            disp([num2str(cnt*linenum) ' reads splitted for marker ' TFname]);
        end
    end
    
    fclose all;
end

