function step6_output_peak_Mvalue_2wig_file(peak_name, workdir, MAtype, outputdir)

clear peak peak1;
commonpeakfile = [workdir, peak_name, '_common_peaks_', MAtype, '_MAvalue.mat'];
load(commonpeakfile);         % peak
peak1 = peak;

clear peak peak2;
uniquepeakfile = [workdir, peak_name, '_unique_peaks_', MAtype, '_MAvalue.mat'];
load(uniquepeakfile);         % peak
peak2 = peak;

clear peak;
peak.chr_id = [peak1.chr_id; peak2.chr_id];
peak.bpsummit = [peak1.bpsummit; peak2.bpsummit];
peak.Mvalue_rescaled = [peak1.Mvalue_rescaled; peak2.Mvalue_rescaled];

fw = fopen([outputdir, peak_name, '_peaks_', MAtype, '_Mvalue.wig'], 'w');
fprintf(fw, 'browser position chr11:5220000-5330000\n');
fprintf(fw, 'track type=wiggle_0 name="%s" visibility=full autoScale=on color=255,0,0 yLineMark=0 yLineOnOff=on priority=10\n', peak_name);
    
chr_id_str = unique(peak.chr_id);
for kk = 1:length(chr_id_str)
	fprintf(fw, 'variableStep chrom=%s span=%d\n', chr_id_str{kk}, 100);

	Isel = find(strcmp(peak.chr_id, chr_id_str{kk}));
    [bpsummit_sort, Isort] = sort(peak.bpsummit(Isel), 'ascend');
        
	for mm = 1:length(Isel)
        fprintf(fw, '%d\t%f\n', peak.bpsummit(Isel(Isort(mm))), peak.Mvalue_rescaled(Isel(Isort(mm))));
    end
end
 fclose(fw);
 
 